<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Class: Menu</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Class: Menu</h1>

    




<section>

<header>
    
        <h2><span class="attribs"><span class="type-signature"></span></span>Menu<span class="signature">(Title)</span><span class="type-signature"></span></h2>
        
            <div class="class-description"><p>Displays a menu and asks user some questions <em>sequentially</em>.</p>
<h3>Example of usage</h3>
<pre class="prettyprint source"><code>// Create the questions for the menu
const questions = [
{
  message: &quot;Choose where to invade:&quot;,
  name: &quot;appType&quot;,
  type: &quot;checkbox&quot;,
  resolver: resolveAppType, // Just to demonstrate the how to use a resolver
  choices: [
    { name: &quot;Frontend web&quot;, value: &quot;frontend&quot;, checked: true },
    { name: &quot;Backend API&quot;, value: &quot;backend&quot;, checked: true }
  ],
  next: [
    {
      message: `What frontend folder do you want to use ?`,
      name: &quot;frontendDirectory&quot;,
      if: &quot;frontend&quot;,
      type: &quot;input&quot;,
      default: &quot;client/&quot;
    }, …
  ],
  filterNext: (val, answerResult, resolverResult) => {
    return resolverResult.indexOf(val.if) > -1;
  },
]

// Launch the menu with the specified questions
const menu = new Menu('Scavader')
menu.run(questions).then( (result) => {
  console.log(result);
}
</code></pre></div>
        
    
</header>

<article>
    <div class="container-overview">
    
        

    
    <h2>Constructor</h2>
    

    
    <h4 class="name" id="Menu"><span class="type-signature"></span>new Menu<span class="signature">(Title)</span><span class="type-signature"></span></h4>
    

    











    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>Title</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>The title to display when running the menu</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="menu.js.html">menu.js</a>, <a href="menu.js.html#line49">line 49</a>
    </li></ul></dd>
    

    

    

    
</dl>




















    
    </div>

    

    

    

    

    

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id="_intro"><span class="type-signature"></span>_intro<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Display the title introduction only once</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="menu.js.html">menu.js</a>, <a href="menu.js.html#line68">line 68</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="_next"><span class="type-signature">(async) </span>_next<span class="signature">(questions, finalDone)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Run the next set of questions</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>questions</code></td>
            

            <td class="type">
            
                
<span class="param-type">array</span>


            
            </td>

            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The questions list to be asked.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>finalDone</code></td>
            

            <td class="type">
            
                
<span class="param-type">function</span>


            
            </td>

            

            
                <td class="default">
                
                    null
                
                </td>
            

            <td class="description last"><p>The final resolver to be executed</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="menu.js.html">menu.js</a>, <a href="menu.js.html#line87">line 87</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id="run"><span class="type-signature"></span>run<span class="signature">(questions)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Launch the menu of questions.</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>questions</code></td>
            

            <td class="type">
            
                
<span class="param-type">array</span>


            
            </td>

            

            

            <td class="description last"><p>The list of questions to be asks.</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="menu.js.html">menu.js</a>, <a href="menu.js.html#line59">line 59</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
    

    

    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="Menu.html">Menu</a></li><li><a href="Scaffold.html">Scaffold</a></li><li><a href="Scavader.html">Scavader</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.2</a> on Fri Jun 07 2019 14:43:53 GMT+0100 (GMT+01:00)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>